// variables liees a la gestion des codeurs


volatile int nbEncochesDr = 0;    // nombre d'encoches comptées par le capteur Droit
volatile int nbEncochesGa = 0;    // nombre d'encoches comptées par le capteur Gauche

unsigned long tMesurePrec=0,tAffichePrec=0;    // temps au moment du calcul de la position précédente
unsigned long tactuel=0;         // temps actuel
long int Teta = 0;               // position angulaire du robot
float MesureD = 0;               // valeur du compteur droit lors de la mesure précédente
float MesureG = 0;               // valeur du compteur gauche lors de la mesure précédente
float PosX = 0;                  // position actuelle en x du robot
float PosY = 0;                  // position actuelle en y du robot
float PosYPrec = 0;              // position actuelle en y du robot lors de la mesure précédente



// variables liees a la gestion des moteurs
# define avant 0
# define arriere 1

# define MGV 10
# define MGD 11

# define MDV 9
# define MDD 8

int VDmax = 250;   //vitesse maximum du moteur droit
int VDmin = 55;    //vitesse minimum du moteur droit
int VGmax = 250;   //vitesse maximum du moteur gauche
int VGmin = 50;    //vitesse minimum du moteur gauche
int vt = 50;      
int cG;      //coefficient qui pilote la vitesse du moteur gauche
int cD;      //coefficient qui pilote la vitesse du moteur droit
float wr;
float wrPrec;
const float L = 233; // largeur du robot (entre les roues) 

char etat=1;           // un etat qui force le robot a accélérer et accélérer progressivement
char stopmoteur =0;    // si =1 on arrette les moteurs


// patte8,9 fils bleu b-a1 b-b1 moteur droit vue du dessous
// patte10,11 fils blanc a-a1 a-b1 moteur gauche vue du dessous



void setup() {

  Serial.begin(115200);
  attachInterrupt(0,FrontCapteurDroit,CHANGE);    // ces interruptions servent a incrémenter ou décrementer la mesure du capteur
  attachInterrupt(1,FrontCapteurGauche,CHANGE) ;

  // declaration des e/s controle moteurs
  pinMode(MDV,OUTPUT);
  pinMode(MDD,OUTPUT);
  pinMode(MGV,OUTPUT);
  pinMode(MGD,OUTPUT);


 MoteurD(avant,0);
 MoteurG(avant,0);
 delay(2000);
 
}




void loop(){

  tactuel = micros();                          // on regarde le temps
  if ((tactuel - tMesurePrec)>= 750) {         // si la dernière mesure de position remonte 
    wrPrec=wr;                                 // a plus de 750 microsecondes
    PosYPrec=PosY;                             // ses dernières mesures sont donc les mesures précédentes pour le nouveau calcul
    calculPosition();                          // puis on relance un calcul de position
    tMesurePrec = tactuel;                     // on relève le temps auquel à été fait la dernière mesure de position
    wr =  -20*Teta;                  // si le robot ne va pas en ligne droite, teta est différent de 0
                                     // on corrige donc sa trajectoire en augmentant la vitesse angulaire
                                     // note si il dévie à gauche => teta est positif, s'il devie à droite => teta est négatif
/*
    if(etat==1) {
      if (PosX < 200) vt=PosX*3;                     //entre 0 et 20 cm
      else if ( (PosX> 200) && ((1000 - PosX)>400))  //entre 20 et 60 cm
      {
        vt=60;
      }   
      else if ((PosX>900) && (PosX<1000))       //entre 90 cm et 1m
          vt=(1000 - PosX)*0.3;
      else if (PosX>=1000) stopmoteur=1; 
      else vt=0;
    }
*/
  if (PosX<1000)  vt=60;
  else vt=(1000-PosX)*6/10;
  if (PosX>1000) stopmoteur=1; 
    cD=vt+wr;                // combiné avec le wr ci-dessus, on corrige la trajectoire pour faire une ligne droite
    if (cD<0) cD=0;                    // minimales et maximales
    if (cD>100) cD=100;                // des coef, (pourcentage)
    cG=vt-wr;                // combiné avec le wr ci-dessus, on corrige la trajectoire pour faire une ligne droite
    if (cG<0) cG=0;
    if (cG>100) cG=100;
    
    if(stopmoteur==0) {    //tant que stop moteur=0 le robot avance

      MoteurD(avant,VDmin + (cD*(VDmax-VDmin))/100);    // la vitesse est calibrée par rapport à la vitesse max et min
      MoteurG(avant,VGmin + (cG*(VGmax-VGmin))/100);
    }
    else {                  // si stopmoteur =1 on arrete les moteurs
      MoteurD(avant,0);
      MoteurG(avant,0);

    }
  }

/*  if ((tactuel - tAffichePrec)>= 50000) {      // cette partie est utile pour comprendre le fonctionnement et donc débugger le robot
    Serial.print("Position X = "); 
    Serial.println(PosX);
    Serial.print("Position Y = ");
    Serial.println(PosY);
    Serial.print("Teta = ");
    Serial.println((float)Teta/(float)L);
    Serial.print("Wr = ");
    Serial.println(wr);    
    tAffichePrec = tactuel;                     // on relève le temps auquel à été fait la mdernière mesure de position
  }
*/
}





//methodes liees aux codeurs


void FrontCapteurDroit() 
{  // attention il faut tester l'ordre de detection pour definir le sens des roues

  uint8_t E4 = PINE & (1<<PE4);
  uint8_t G5 = PING & (1<<PG5);

  if (E4 ==0)                   // ici le capteur droit est associe a 2 et 4 pour eme1 et eme2
  { 
    if (G5 ==0) nbEncochesDr-- ;
    else nbEncochesDr++ ;
  }
  else
  {
    if (G5 ==0) nbEncochesDr++ ;
    else nbEncochesDr-- ;
  }
}

void FrontCapteurGauche() {                     // idem avec 3 et 5

  uint8_t E3 = PINE & (1<<PE3);
  uint8_t E5 = PINE & (1<<PE5);

  if (E3 ==0)                   // ici le capteur droit est associe a 2 et 4 pour eme1 et eme2
  { 
    if (E5 ==0) nbEncochesGa-- ;
    else nbEncochesGa++ ;
  }
  else
  {
    if (E5 ==0) nbEncochesGa++ ;
    else nbEncochesGa-- ;
  }
}

void calculPosition() {      // Calcul de la position actuelle du robot
  float DeltaMoy = 0;
  float DeltaDif = 0;
  float DeltaPosX = 0;              // on réinitialise les valeurs
  float DeltaPosY = 0;
  double DeltaTeta = 0;
  float DistD = 0;                   // distance parcourue par la roue droite
  float DistG = 0;                   // distance parcourue par la roue gauche
  
  float TetaCalc;


  DistD = nbEncochesDr*0.5110038;
  DistG = nbEncochesGa*0.511;
  DeltaTeta = DistD-DistG;      //nbEncochesDr-nbEncochesGa;
  nbEncochesDr=0;
  nbEncochesGa=0;
  DeltaMoy = ((DistD + DistG))/2;
  DeltaDif =  (DistD - DistG);

  Teta = Teta + DeltaTeta;
  TetaCalc=(float)Teta/(float)L;
  DeltaPosX = DeltaMoy*cos(TetaCalc);
  DeltaPosY = DeltaMoy*sin(TetaCalc);  
  PosX = PosX + DeltaPosX;
  PosY = PosY + DeltaPosY;

  //  Serial.print("DeltaMoy = ");        //idem, utile pour débugger
  //  Serial.println(DeltaMoy);
  //  Serial.print("DeltaDif = ");
  //  Serial.println(DeltaDif);
  //  Serial.print("DeltaTeta = ");
  //  Serial.println(DeltaTeta);
  //  Serial.print("DeltaPosX = ");
  //  Serial.println(DeltaPosX);
  //  Serial.print("DeltaPosY = ");
  //  Serial.println(DeltaPosY);


}



//methodes liees aux moteurs

void MoteurG(unsigned char d, unsigned char v) {    // gestion avant arriere des moteurs gauche et droit
  if( d == avant)
  {
    digitalWrite( MGD, HIGH ); 
    analogWrite( MGV, 255-v ); 
  }
  if( d == arriere)
  {
    digitalWrite( MGD, LOW ); 
    analogWrite( MGV, v ); 
  }
}

void MoteurD(unsigned char d,unsigned char v) {
  if( d == avant)
  {
    digitalWrite( MDD, HIGH ); 
    analogWrite( MDV, 255-v ); 
  }
  if( d == arriere)
  {
    digitalWrite( MDD, LOW ); 
    analogWrite( MDV, v );
  }
}















